

int [][] dataMatrix = null;
int numRows = 15;           //7 books and 8 movies
int numColumns = 576;       //1970, 2004-2014 (12) are the included years * 12 months

PFont funFont1 = createFont("Courier", 14, true);
PFont funFont2 = createFont("Chalkboard", 24, true);
PFont funFont3 = createFont("Apple Chancery", 24, true);

PFont font1    = createFont("Arial", 12, true);     //:(
PFont font2    = createFont("Helvetica", 18, true); //:(

Table myTable;

int cellWidth  = 9;
int cellHeight = 18;
int rowMargin  = 100;
int colMargin  = 100;

void setup()
{
  size(1490, 560);
  background(255);
  smooth();
  println("SetUp Done!");
  myTable = loadTable("HP_Summary.csv", "header");
  
  println("Rows: " + myTable.getRowCount());
  println("Columns: " + myTable.getColumnCount());
  println(144 * 15);

  dataMatrix = new int[numRows][numColumns];
  
  int k = 0;
  int m = 0;
  println("---------------------BEGIN--------------------");
  for(int i = 0; i < myTable.getRowCount(); i++)
  {
    for(int j = 1; j < myTable.getColumnCount(); j++)
    {
      dataMatrix[k][m] = myTable.getInt(i,j);
      m++;
 
      //print("(K,M: " + k + "," + m + "), (i,j: " + i + "," + j + "), " + myTable.getInt(i,j) + ", ");
      //println(k + ", " + m);

      if(m == 576)
      {
        m = 0;
        k++;
      }
    }
  }
}

void draw()
{
  background(255);
  stroke(0, 0, 0, 100);
  strokeWeight(0.2);
  
  //Background with Transparency
  fill(255,0,0,10);
  rect(0, 0, width, height);

  //Background for Cells
  fill(255);
  rect(rowMargin, colMargin, cellWidth * (numColumns/4), cellHeight * numRows);
  
  //Outline Border for Cells
  noFill();
  rect(rowMargin, colMargin, cellWidth * (numColumns/4), cellHeight * numRows);
  
  //Title
  textAlign(CENTER, CENTER);
  //textFont(funFont2);
  textFont(font2);
  fill(101, 55, 253);
  text("Harry Potter Book and Movie Checkouts", width / 2, height * 0.14);
  
  //Data Cells
  //colorMode(HSB); //looks ugly =[
  for(int i = 0, k = 0; i < numColumns; i+= 4, k++)
  {
    for(int j = 0; j < numRows; j++)
    {
      stroke(255, 153, 255, 100);
      strokeWeight(0.014);
      fill(((float)dataMatrix[j][i + 1] * 255.0) / 12.0, //month
      (((float)dataMatrix[j][i] + 1.0) * 14.0) / 2.0, //book or movie
      dataMatrix[j][i + 2] % 255, //year
      ((float)dataMatrix[j][i + 3]/494.0) * 255.0); //checkouts
      
      rect(rowMargin + k * cellWidth, colMargin + j * cellHeight, cellWidth, cellHeight);
    }
  }
  
  //Line Annual Separators
  for(int i = 0, k = 0; i < numColumns; i += 4, k++)
  {
    stroke(101, 55, 253, 100);
    strokeWeight(1);
    
    if(k == 0)
      line(rowMargin + (k * cellWidth), 
      colMargin + numRows * cellHeight, 
      rowMargin + (k * cellWidth), 
      colMargin + numRows * cellHeight + 15);
      
    if((k + 1) % 12 == 0)
      line(rowMargin + ( (k + 1) * cellWidth), 
      colMargin + numRows * cellHeight, 
      rowMargin + ( (k + 1) * cellWidth), 
      colMargin + numRows * cellHeight + 15);
  }
  
  //Row Labels
  String[] labels = {"Book 1", "Film 1", "Book 2", "Film 2", "Book 3", "Film 3",
                     "Book 4", "Film 4", "Book 5", "Film 5", "Book 6", "Film 6",
                     "Book 7", "Film 7", "Film 8"};
  
  textAlign(CENTER, CENTER);
  //textFont(funFont1);               
  textFont(font1);
  fill(101, 55, 253, 200);
  //fill(128, 3, 253);

  for(int i = 0; i < 1500; i += 100)
    text(labels[i/100], 
    rowMargin * 0.7, 
    colMargin + cellHeight / 2 + i / 100 * cellHeight);
  
  //Column Labels
  textAlign(RIGHT, CENTER);
  String[] yearL = {"1970", "2004", "2005", "2006", "2007", "2008", "2009", "2010", "2011",
                    "2012", "2013", "2014"};
                    
  for(int i = 1; i <= 144; i++)
  {
    if(i % 12 == 0 )
    {
      text(yearL[i / 12 - 1],
      rowMargin - (cellWidth / 2) + (i * cellWidth) - (cellWidth * 3.5),
      height - 1.8 * colMargin);
    }
  }
  
  //Signature 
  /*
  textAlign(CENTER, CENTER);
  textFont(funFont3);
  fill(101, 55, 253, 214);
  text("by Nataly Moreno", width - (width * 0.15), height - (height * 0.15) );
  */
  
}
